#include "arithcommon.h"
#include <stdlib.h>
#include <math.h>
#include <float.h>

/**
 * Generate Random number in single precision.
 */
float random_float(int emin, int emax, int pos_neg){
    double tmp;
    unsigned int i, val;
    int e;

    val = (rand() & 0x000000ff);
    for(i=0; i<(sizeof(int)); i++){
	val = val << 8;
	val += (rand() & 0x000000ff ); /* we keep only 8 bits */
    }
    e = emin + (int)( (double)rand()*(emax-emin)/(double)RAND_MAX);
    tmp = ldexp(1.0 + (double)val / UINT_MAX, e);
    if ((pos_neg) && (rand() > (RAND_MAX/2)))		tmp *= -1;

    return (float)tmp;
}

// assumes not-too-distant bounds...
float random_float_interval(float fmin, float fmax)
{
    /*long val = (rand() & 0x000000ff);
    for(int i=1; i<(sizeof(long)); i++){
	val = val << 8;
	val += (rand() & 0x000000ff );
	}*/
	float v;
	do {
		double rndval = ((double)rand() + ((double)rand() / (2 * ((double)RAND_MAX)+1.0))) / ((double)RAND_MAX+1.0);
		v = (float)(fmin + ((double)fmax - (double)fmin) * rndval);
	} while(v == fmax);	// open-ended interval
	return v;
}
