
/*
  This file contains constants defined for use by the GPUBench framework
  and calling code.

*/

#ifndef __GPUBENCH_ENUM_H__
#define __GPUBENCH_ENUM_H__



/* Architecture specifiers ------------------------------- */

#define GPUBENCH_ARCH_UNKNOWN           0
#define GPUBENCH_ARCH_ATI               1
#define GPUBENCH_ARCH_NV                2
#define GPUBENCH_ARCH_3DLABS            3

/* Data access pattern specifiers for _render() calls */

#define GPUBENCH_ACCESS_SINGLE          0
#define GPUBENCH_ACCESS_SEQ             1


/* Config flags ------------------------------------------ */

#define GPUBENCH_FLAG_EXITONERROR       0
#define GPUBENCH_FLAG_VERBOSE           1


/* Error handling ---------------------------------------- */

#define GPUBENCH_ERROR_NONE             0
#define GPUBENCH_ERROR_INVALID_FLAG     1
#define GPUBENCH_ERROR_SHADER_LOAD      2
#define GPUBENCH_ERROR_SHADER_BIND      3
#define GPUBENCH_ERROR_PBUFFER_CREATE   4


/* Misc Defines ------------------------------------------ */

#define GPUBENCH_BOGUS_PROGRAM          -1

#define GPUBENCH_STR_LENGTH             1024







#endif // __GPUBENCH_ENUM_H__
