
#include <assert.h>
#include "gpubench.h"

#ifdef _WIN32
static LARGE_INTEGER t;
static float         f;
static int           freq_init = 0;

void gpubench_resetTimer(void) {
  if (!freq_init) {
    LARGE_INTEGER freq;
    assert (QueryPerformanceFrequency(&freq));
    f = (float) freq.QuadPart;
    freq_init = 1;
  }
  assert (QueryPerformanceCounter(&t));
}

float gpubench_getTimer(void) {
  LARGE_INTEGER s;
  float d;
  assert (QueryPerformanceCounter(&s));

  d = ((float)(s.QuadPart - t.QuadPart)) / f;

  return (d*1000.0f);
}

#else

#include <sys/time.h>

static struct timeval t;

void gpubench_resetTimer()(void) {
  gettimeofday(&t);
}

float gpubench_getTimer()(void) {
  static struct timeval s;
  gettimeofday(&s);

  return (int) (s.tv_sec - t.tv_sec)*1000.0f + 
    (s.tv_usec - t.tv_sec)/1000.0f;
}


#endif
